#include <RH_ASK.h>
#include <SPI.h> 
#include <Wire.h>
#include <SFE_BMP180.h>
#include "DHT.h";

SFE_BMP180 bmp180;

#define DHTPIN 10       // DHT-22 Output Pin connection
#define DHTTYPE DHT22   // DHT Type is DHT 22 (AM2302)

float hum;    // Stores humidity value in percent
float temp;   // Stores temperature value in Celcius

String str_humid;
String str_temp1;
String str_press;
String str_temp2;
float str_temp;
String str_out;

unsigned long long previousMillis = 0;
const long interval = 3000; 

RH_ASK rf_driver;
DHT dht(DHTPIN, DHTTYPE);
 
// define pin used
const int stepPin = 3;
const int dirPin = 2;
const int stepPin2 = 9;
const int dirPin2 = 8;

int lightRightUp = A1; 
int lightRightDown = A0;
int lightLeftDown = A2;
int lightLeftUp = A3;

int rust = 2500;
int accuracy = 30;

int dir = 0;
 
 void setup() {
 // set the two pins as outputs
  pinMode(stepPin,OUTPUT);
  pinMode(dirPin,OUTPUT);

  pinMode(stepPin2,OUTPUT);
  pinMode(dirPin2,OUTPUT);

  rf_driver.init();
  dht.begin();
  bool success = bmp180.begin();
  Serial.begin(9600);
}

void loop() {
  Serial.println("loop");
  char status;
  double T, P;
  bool success = false;
  status = bmp180.startTemperature();
  unsigned long long currentMillis = millis();

  if (currentMillis - previousMillis >= interval) {
    previousMillis = currentMillis;

    hum = dht.readHumidity();  // Get Humidity value
    temp= dht.readTemperature();  // Get Temperature value

    if (status != 0){
      status = bmp180.getTemperature(T);
      status = bmp180.startPressure(3);
      delay(status);
      status = bmp180.getPressure(P, T);
    }

    str_humid = String(hum);
    str_temp1 = String(temp);
    str_press = String(P);
    str_temp2 = String(T);
    str_temp = (temp + T) /2;

    str_out = str_press + str_humid + String(str_temp);

    static char *msg = str_out.c_str();
    Serial.println(msg);
    Serial.println(strlen(msg));
  
    rf_driver.send((uint8_t *)msg, strlen(msg));
    rf_driver.waitPacketSent();
  }
   
  int valueLightRightUp = analogRead(lightRightUp);
  int valueLightRightDown = analogRead(lightRightDown);
  int valueLightLeftDown = analogRead(lightLeftDown);
  int valueLightLeftUp = analogRead(lightLeftUp);

  if((valueLightRightUp - valueLightLeftUp) > accuracy || (valueLightRightDown - valueLightLeftDown) > accuracy)
  {
    digitalWrite(dirPin2,LOW);
    digitalWrite(stepPin2,HIGH);
    delayMicroseconds(rust);
    digitalWrite(stepPin2,LOW);
    delayMicroseconds(rust);
    dir = 1;
  }
  if((valueLightLeftUp - valueLightRightUp) > accuracy || (valueLightLeftDown - valueLightRightDown) > accuracy && dir != 1)
  {
    digitalWrite(dirPin2,HIGH);
    digitalWrite(stepPin2,HIGH);
    delayMicroseconds(rust);
    digitalWrite(stepPin2,LOW);
    delayMicroseconds(rust);
  }
  if((valueLightRightUp - valueLightRightDown) > accuracy || (valueLightLeftUp - valueLightLeftDown) > accuracy)
  {
    digitalWrite(dirPin,LOW);
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(rust);
    digitalWrite(stepPin,LOW);
    delayMicroseconds(rust);
    dir = 2;
  }
  if((valueLightRightDown - valueLightRightUp) > accuracy || (valueLightLeftDown - valueLightLeftUp) > accuracy && dir != 2)
  {
    digitalWrite(dirPin,HIGH);
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(rust);
    digitalWrite(stepPin,LOW);
    delayMicroseconds(rust);
  }
  dir = 0;
  //delay(30);
}
